adBuffBarConfig = {};
_G.adBuffBarConfig = adBuffBarConfig;

function adBuffBarsConfigReset()
	adBuffBarConfig["WARNING_TIME"] = 20;
	adBuffBarConfig["BARS_SCALE"] = 1;
	adBuffBarConfig["BARS_WIDTH"] = 180;
	adBuffBarConfig["FLASH"] = true;
	adBuffBarConfig["FLASH_TO_RED"] = false;
	adBuffBarConfig["FILLS"] = true;
	adBuffBarConfig["INVERT_FILLING"] = false;
	adBuffBarConfig["BUFFS_AMOUNT"] = 12;
	adBuffBarConfig["DEBUFFS_AMOUNT"] = 12;
	adBuffBarConfig["ICONS"] = true;
	adBuffBarConfig["SHRINK"] = false;
	adBuffBarConfig["LOCKED"] = false;
	adBuffBarConfig["MIRROR"] = false;
	adBuffBarConfig["SNAP"] = "LEFT";
	adBuffBarConfig["SHORTTIME"] = true;
	adBuffBarConfig["COLORS"]["BUFFS"] = {
		r = 0.2,
		g = 0.8,
		b = 0.8,
	};
	adBuffBarConfig["COLORS"]["DEBUFFS"] = {
		r = 0.6,
		g = 0.6,
		b = 0.8,
	};
	adBuffBarConfig["SKIN"] = "Interface\\Common\\BarFill";
	adBuffBarConfig["BUFFS_POSITION"] = {
		[1] = 500,
		[2] = 200,
	};
	adBuffBarConfig["DEBUFFS_POSITION"] = {
		[1] = 302,
		[2] = 200,
	};
	SaveVariables("adBuffBarConfig");
	adBuffBarsConfigUpdateUI();
end

function adBuffBarsConfigSave()
	adBuffBarConfig["WARNING_TIME"] = adBuffBarConfigFrameFlashTimeSlider:GetValue();
	adBuffBarConfig["BARS_SCALE"] = adBuffBarConfigFrameBarScaleSlider:GetValue();
	adBuffBarConfig["BARS_WIDTH"] = adBuffBarConfigFrameBarWidthSlider:GetValue();
	adBuffBarConfig["FLASH"] = adBuffBarConfigFrameFlashCheckButton:IsChecked();
	adBuffBarConfig["FLASH_TO_RED"] = adBuffBarConfigFrameFlashToRedCheckButton:IsChecked();
	adBuffBarConfig["FILLS"] = adBuffBarConfigFrameFillsCheckButton:IsChecked();
	adBuffBarConfig["INVERT_FILLING"] = adBuffBarConfigFrameInvertFillingCheckButton:IsChecked();
	adBuffBarConfig["BUFFS_AMOUNT"] = adBuffBarConfigFrameBuffsAmountSlider:GetValue();
	adBuffBarConfig["DEBUFFS_AMOUNT"] = adBuffBarConfigFrameDebuffsAmountSlider:GetValue();
	adBuffBarConfig["ICONS"] = adBuffBarConfigFrameIconsCheckButton:IsChecked();
	adBuffBarConfig["SHRINK"] = adBuffBarConfigFrameShrinkCheckButton:IsChecked();
	adBuffBarConfig["LOCKED"] = adBuffBarConfigFrameLockedCheckButton:IsChecked();
	adBuffBarConfig["MIRROR"] = adBuffBarConfigFrameMirrorCheckButton:IsChecked();
	adBuffBarConfig["SHORTTIME"] = adBuffBarConfigFrameShortTimeCheckButton:IsChecked();
	
	getglobal("adBuffBarBuffs"):SetScale(adBuffBarConfig["BARS_SCALE"]);
	getglobal("adBuffBarDebuffs"):SetScale(adBuffBarConfig["BARS_SCALE"]);
	
	adBuffBarConfig["BUFFS_POSITION"] = {adBuffBarBuff1:GetPos()};
	adBuffBarConfig["DEBUFFS_POSITION"] = {adBuffBarDebuff1:GetPos()};
	SaveVariables("adBuffBarConfig");
	adBuffBarsConfigUpdateUI();
end

function adBuffBarsConfigUpdateUI()
	adBuffBarConfigFrameBarWidthSlider:SetValue(adBuffBarConfig["BARS_WIDTH"]);
	adBuffBarConfigFrameBarScaleSlider:SetValue(adBuffBarConfig["BARS_SCALE"]);
	adBuffBarConfigFrameFlashTimeSlider:SetValue(adBuffBarConfig["WARNING_TIME"]);
	adBuffBarConfigFrameFlashCheckButton:SetChecked(adBuffBarConfig["FLASH"]);
	adBuffBarConfigFrameFlashToRedCheckButton:SetChecked(adBuffBarConfig["FLASH_TO_RED"]);
	adBuffBarConfigFrameFillsCheckButton:SetChecked(adBuffBarConfig["FILLS"]);
	adBuffBarConfigFrameInvertFillingCheckButton:SetChecked(adBuffBarConfig["INVERT_FILLING"]);
	adBuffBarConfigFrameBuffsAmountSlider:SetValue(adBuffBarConfig["BUFFS_AMOUNT"]);
	adBuffBarConfigFrameDebuffsAmountSlider:SetValue(adBuffBarConfig["DEBUFFS_AMOUNT"]);
	adBuffBarConfigFrameIconsCheckButton:SetChecked(adBuffBarConfig["ICONS"]);
	adBuffBarConfigFrameShrinkCheckButton:SetChecked(adBuffBarConfig["SHRINK"]);
	adBuffBarConfigFrameLockedCheckButton:SetChecked(adBuffBarConfig["LOCKED"]);
	adBuffBarConfigFrameMirrorCheckButton:SetChecked(adBuffBarConfig["MIRROR"]);
	adBuffBarConfigFrameColorsBuffsTexture:SetColor(adBuffBarConfig["COLORS"]["BUFFS"].r,adBuffBarConfig["COLORS"]["BUFFS"].g,adBuffBarConfig["COLORS"]["BUFFS"].b);
	adBuffBarConfigFrameColorsDebuffsTexture:SetColor(adBuffBarConfig["COLORS"]["DEBUFFS"].r,adBuffBarConfig["COLORS"]["DEBUFFS"].g,adBuffBarConfig["COLORS"]["DEBUFFS"].b);
	adBuffBarConfigFrameShortTimeCheckButton:SetChecked(adBuffBarConfig["SHORTTIME"]);
	adBuffBar:SetSkin(adBuffBarConfig["SKIN"]);
	
	getglobal("adBuffBarBuffs"):SetScale(adBuffBarConfig["BARS_SCALE"]);
	getglobal("adBuffBarDebuffs"):SetScale(adBuffBarConfig["BARS_SCALE"]);
	
		local scale = GetUIScale();
		adBuffBarBuff1:ClearAllAnchors();
		adBuffBarBuff1:SetAnchor("TOPLEFT", "TOPLEFT", "UIParent", adBuffBarConfig["BUFFS_POSITION"][1] / adBuffBarConfig["BARS_SCALE"] / scale, adBuffBarConfig["BUFFS_POSITION"][2] / adBuffBarConfig["BARS_SCALE"] / scale);
		adBuffBarDebuff1:ClearAllAnchors();
		adBuffBarDebuff1:SetAnchor("TOPLEFT", "TOPLEFT", "UIParent", adBuffBarConfig["DEBUFFS_POSITION"][1] / adBuffBarConfig["BARS_SCALE"] / scale, adBuffBarConfig["DEBUFFS_POSITION"][2] / adBuffBarConfig["BARS_SCALE"] / scale);
	if (adBuffBarConfig["SNAP"]) then
		adBuffBarsSnap(adBuffBarConfig["SNAP"]);
	end
	
	if ( adBuffBarConfigFrameLockedCheckButton:IsChecked() ) then
		adBuffBarBuffsAnchor:Hide();
		adBuffBarDebuffsAnchor:Hide();
	else
		adBuffBarBuffsAnchor:Show();
		adBuffBarDebuffsAnchor:Show();
	end
	
	for i=1,24 do
		if ( adBuffBarConfigFrameIconsCheckButton:IsChecked() ) then
			getglobal("adBuffBarBuff"..i.."Icon"):Show();
		else
			getglobal("adBuffBarBuff"..i.."Icon"):Hide();
		end
		if ( not adBuffBarConfigFrameShrinkCheckButton:IsChecked() ) then
			getglobal("adBuffBarBuff"..i.."Name"):Show();
			getglobal("adBuffBarBuff"..i.."Name"):SetWidth(adBuffBarConfig["BARS_WIDTH"]-20);
			getglobal("adBuffBarBuff"..i):SetWidth(adBuffBarConfig["BARS_WIDTH"]);
		else
			getglobal("adBuffBarBuff"..i.."Name"):Hide();
			getglobal("adBuffBarBuff"..i):SetWidth(30);
		end
		if ( i > adBuffBarConfig["BUFFS_AMOUNT"] ) then
			getglobal("adBuffBarBuff"..i):Hide();
		end
		local p, rP, rT, x, y = getglobal("adBuffBarBuff"..i.."Icon"):GetAnchor();
		getglobal("adBuffBarBuff"..i.."Icon"):ClearAllAnchors();
		if ( adBuffBarConfigFrameMirrorCheckButton:IsChecked() ) then
			getglobal("adBuffBarBuff"..i.."Icon"):SetAnchor("LEFT", "RIGHT", rT, 0, y);
		else
			getglobal("adBuffBarBuff"..i.."Icon"):SetAnchor("RIGHT", "LEFT", rT, 0, y);
		end
	end
	for i=1,12 do
		if ( adBuffBarConfigFrameIconsCheckButton:IsChecked() ) then
			getglobal("adBuffBarDebuff"..i.."Icon"):Show();
		else
			getglobal("adBuffBarDebuff"..i.."Icon"):Hide();
		end
		if ( not adBuffBarConfigFrameShrinkCheckButton:IsChecked() ) then
			getglobal("adBuffBarDebuff"..i.."Name"):Show();
			getglobal("adBuffBarDebuff"..i.."Name"):SetWidth(adBuffBarConfig["BARS_WIDTH"]-20);
			getglobal("adBuffBarDebuff"..i):SetWidth(adBuffBarConfig["BARS_WIDTH"]);
		else
			getglobal("adBuffBarDebuff"..i.."Name"):Hide();
			getglobal("adBuffBarDebuff"..i):SetWidth(30);
		end
		if ( i > adBuffBarConfig["DEBUFFS_AMOUNT"] ) then
			getglobal("adBuffBarDebuff"..i):Hide();
		end
		local p, rP, rT, x, y = getglobal("adBuffBarDebuff"..i.."Icon"):GetAnchor();
		getglobal("adBuffBarDebuff"..i.."Icon"):ClearAllAnchors();
		if ( adBuffBarConfigFrameMirrorCheckButton:IsChecked() ) then
			getglobal("adBuffBarDebuff"..i.."Icon"):SetAnchor("LEFT", "RIGHT", rT, 0, y);
		else
			getglobal("adBuffBarDebuff"..i.."Icon"):SetAnchor("RIGHT", "LEFT", rT, 0, y);
		end
	end
end

--------------------------------------------------------
function adBuffBarsScrollBar_OnValueChanged(this, arg1)
	UIPanelScrollBar_OnValueChanged(this, arg1);

	adBuffBarsScrollBarUpdate(this);
end

--------------------------------------------------------
function adBuffBarsScrollBar_OnMouseWheel(this, delta)
	if ( delta > 0 ) then
		UIPanelScrollBarTemplate_Scroll(this, "UP");
	else
		UIPanelScrollBarTemplate_Scroll(this, "DOWN");
	end
end

--------------------------------------------------------
function adBuffBarsScrollBarUpdate(this)
	local p,rP,rT,x,y = adBuffBarConfigFrameBarWidth:GetAnchor();
	adBuffBarConfigFrameBarWidth:ClearAllAnchors();
	adBuffBarConfigFrameBarWidth:SetAnchor(p,rP,rT,x,90-25*this:GetValue())
	if (this:GetValue() == 0) then
		if adBuffBarConfigFrameMirror:IsVisible() then
			adBuffBarConfigFrameMirror:Hide();
			adBuffBarConfigFrameBarWidth:Show();
		end
	elseif (this:GetValue() == 1) then
		if adBuffBarConfigFrameBarWidth:IsVisible() then
			adBuffBarConfigFrameBarWidth:Hide();
			adBuffBarConfigFrameMirror:Show();
		else
			adBuffBarConfigFrameBarScale:Show();
			adBuffBarConfigFrameSnap:Hide();
		end
	elseif (this:GetValue() == 2) then
		if adBuffBarConfigFrameBarScale:IsVisible() then
			adBuffBarConfigFrameBarScale:Hide();
			adBuffBarConfigFrameSnap:Show();
		else
			adBuffBarConfigFrameFlashTime:Show();
			adBuffBarConfigFrameColors:Hide();
		end
	elseif (this:GetValue() == 3) then
		if adBuffBarConfigFrameFlashTime:IsVisible() then
			adBuffBarConfigFrameFlashTime:Hide();
			adBuffBarConfigFrameColors:Show();
		else
			adBuffBarConfigFrameFlash:Show();
			adBuffBarConfigFrameShortTime:Hide();
		end
	elseif (this:GetValue() == 4) then
		if adBuffBarConfigFrameFlash:IsVisible() then
			adBuffBarConfigFrameFlash:Hide();
			adBuffBarConfigFrameShortTime:Show();
		end
	end
end

function adBuffBarsColorsBuffsUpdate()
	adBuffBarConfigFrameColorsBuffsTexture:SetColor(ColorPickerFrame.r, ColorPickerFrame.g, ColorPickerFrame.b);
	adBuffBarConfig["COLORS"]["BUFFS"] = {
		r = ColorPickerFrame.r,
		g = ColorPickerFrame.g,
		b = ColorPickerFrame.b,
	};
end

function adBuffBarsColorsDebuffsUpdate()
	adBuffBarConfigFrameColorsDebuffsTexture:SetColor(ColorPickerFrame.r, ColorPickerFrame.g, ColorPickerFrame.b);
	adBuffBarConfig["COLORS"]["DEBUFFS"] = {
		r = ColorPickerFrame.r,
		g = ColorPickerFrame.g,
		b = ColorPickerFrame.b,
	};
end

--------------------------------------------------------
function adBuffBarsSnap(v)
	adBuffBarConfig["SNAP"] = v;
	local scale = GetUIScale();
	if (v == "LEFT") then
		adBuffBarDebuff1:ClearAllAnchors();
		if (adBuffBarConfig["MIRROR"]) then
			adBuffBarDebuff1:SetAnchor("RIGHT","LEFT","adBuffBarBuff1",-18,0);
		else
			adBuffBarDebuff1:SetAnchor("RIGHT","LEFT","adBuffBarBuff1",-18,0);
		end
	elseif (v == "TOP") then
		adBuffBarDebuff1:ClearAllAnchors();
		adBuffBarBuff1:ClearAllAnchors();
		adBuffBarBuff1:SetAnchor("TOPLEFT", "TOPLEFT", "UIParent", adBuffBarConfig["BUFFS_POSITION"][1] / adBuffBarConfig["BARS_SCALE"] / scale, adBuffBarConfig["BUFFS_POSITION"][2] / adBuffBarConfig["BARS_SCALE"] / scale);
		adBuffBarDebuff1:SetAnchor("BOTTOM","TOP","adBuffBarBuff1",0,0);
	elseif (v == "RIGHT") then
		adBuffBarDebuff1:ClearAllAnchors();
		if (adBuffBarConfig["MIRROR"]) then
			adBuffBarDebuff1:SetAnchor("LEFT","RIGHT","adBuffBarBuff1",18,0);
		else
			adBuffBarDebuff1:SetAnchor("LEFT","RIGHT","adBuffBarBuff1",18,0);
		end
	elseif (v == "BOTTOM") then
		adBuffBarDebuff1:ClearAllAnchors();
		adBuffBarBuff1:ClearAllAnchors();
		adBuffBarBuff1:SetAnchor("TOPLEFT", "TOPLEFT", "UIParent", adBuffBarConfig["BUFFS_POSITION"][1] / adBuffBarConfig["BARS_SCALE"] / scale, adBuffBarConfig["BUFFS_POSITION"][2] / adBuffBarConfig["BARS_SCALE"] / scale);
		adBuffBarDebuff1:SetAnchor("TOP","BOTTOM","adBuffBarBuff1",0,0);
	end
end

function adBuffBars_GetWords(str)
	local ret = {};
	local pos=0;
	while(true) do
		local word;
		_,pos,word=string.find(str, "^ *([^%s]+) *", pos+1);
		if(not word) then
			return ret;
		end
		table.insert(ret, word);
	end
end

SLASH_adBuffBarsConfig1 = "/adbbconfig";
SLASH_adBuffBarsConfig2 = "/adbuffbars";
SLASH_adBuffBarsConfig3 = "/adbb";

SlashCmdList["adBuffBarsConfig"] = function (ebox, msg)
	local msg = string.lower(msg);
	local wL = adBuffBars_GetWords(msg);
	
	if wL[1] == "lock" then adBuffBarConfig["LOCKED"] = true;
	elseif wL[1] == "unlock" then adBuffBarConfig["LOCKED"] = false;
	elseif wL[1] == "flashstarttime" or wL[1] == "fst" then adBuffBarConfig["WARNING_TIME"] = wL[2];
	elseif wL[1] == "scale" then adBuffBarConfig["BARS_SCALE"] = wL[2];
	elseif wL[1] == "snap" then adBuffBarConfig["SNAP"] = wL[2];
	elseif wL[1] == "shrink" then adBuffBarConfig["SHRINK"] = true;
	elseif wL[1] == "unshrink" then adBuffBarConfig["SHRINK"] = false;
	elseif wL[1] == "unsnap" then adBuffBarConfig["SNAP"] = "NONE";
	elseif wL[1] == "show" then adBuffBarBuffs:Show(); adBuffBarDebuffs:Show();
	elseif wL[1] == "hide" then adBuffBarBuffs:Hide(); adBuffBarDebuffs:Hide();
	elseif wL[1] == "reset" then adBuffBarsConfigReset();
	elseif wL[1] == "skin" then adBuffBar:SetSkin("Interface\\AddOns\\adbuffbars\\textures\\bars\\"..wL[2]);
	elseif wL[1] == "mirror" then adBuffBarConfig["MIRROR"] = true;
	elseif wL[1] == "unmirror" then adBuffBarConfig["MIRROR"] = false;
	else ShowUIPanel(adBuffBarConfigFrame);
	end
	
	adBuffBarsConfigUpdateUI();
	SaveVariables("adBuffBarConfig");
end
